function [ err_rel2, err_rel_trunc2, err_rel_alias2, err_rel1, err_rel_trunc1, err_rel_alias1 ] = bspline2t_cl_singletest( freq, z, M )
%BSPLINE2T_CL_SINGLETEST Summary of this function goes here
%   Detailed explanation goes here

d = length(z);

chat_out = cheb_poly_reco( freq, z, M, @bspline2t_nd );
chat = bspline2t_chat_nd(freq);

[fct_bspline2t_normL2_val, fct_bspline2t_normL2_val_sq] = bspline2t_normcheb(d);
fct_bspline2t_normA_val = bspline2t_chat_norm1(d);


fprintf('norm fct A: %.6e, L2w: %.6e, ', fct_bspline2t_normA_val, fct_bspline2t_normL2_val);

% err_rel_trunc2 = sqrt(bspline2t_normcheb(d)^2 - pi^d * sum(abs(chat).^2 ./ 2.^(sum(freq~=0,2)))) / bspline2t_normcheb(d);
err_rel_trunc2 = sqrt(fct_bspline2t_normL2_val_sq - pi^d * sum(sort(abs(chat).^2 ./ 2.^(sum(freq~=0,2))))) / fct_bspline2t_normL2_val;
% fprintf('rel. truncation err.: %.3e, ', err_rel_trunc2);
err_rel_alias2 = pi^(d/2) * sqrt(sum(sort(abs(chat_out-chat).^2 ./ 2.^(sum(freq~=0,2))))) / fct_bspline2t_normL2_val;
% fprintf('rel. aliasing err.: %.3e\n', err_rel_alias2);

%err_l2_rel = sqrt( norm_fct_square - norm(fhat,2)^2 + norm(fhat_out-fhat,2)^2 ) / sqrt(norm_fct_square);
err_rel2 = sqrt(fct_bspline2t_normL2_val_sq - pi^d * sum(sort(abs(chat).^2 ./ 2.^(sum(freq~=0,2)))) + pi^d * sum(sort(abs(chat_out-chat).^2 ./ 2.^(sum(freq~=0,2))))) / fct_bspline2t_normL2_val;

err_rel_trunc1 = ( fct_bspline2t_normA_val - sum(sort(abs(chat))) ) / fct_bspline2t_normA_val;
err_rel_alias1 = sum(sort(abs(chat_out-chat))) / fct_bspline2t_normA_val;
err_rel1 = ( fct_bspline2t_normA_val - sum(sort(abs(chat))) + sum(sort(abs(chat_out-chat))) ) / fct_bspline2t_normA_val;
fprintf('relative errors A: %3e (%.3d|%.3e), L2w: %3e (%.3d|%.3e)\n', err_rel1, err_rel_trunc1, err_rel_alias1, err_rel2, err_rel_trunc2, err_rel_alias2);

end

