function [ x_hat ] = fct1( x )
%FCT1 Fast computation of one-dimensional DCT-I via one-dimensional FFT.
%
%   Input parameter:
%      x - input coefficients
%
%    Ouput parameter:
%       x_hat - transformed coefficients
%
% Copyright (c) 2015 Toni Volkmer
%
% This program is free software; you can redistribute it and/or modify it under
% the terms of the GNU General Public License as published by the Free Software
% Foundation; either version 2 of the License, or (at your option) any later
% version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
% details.
%
% You should have received a copy of the GNU General Public License along with
% this program; if not, write to the Free Software Foundation, Inc., 51
% Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

x = x(:);

if length(x) > 2
  y = [x(1:end); fliplr(x(2:end-1)')'];
  x_hat = real(fft(y));
  x_hat = x_hat(1:length(x))/2;
else
  x_hat = x;
end


end

